"use strict";

function MyApp()
{
    function getTagOption(value, text){
        return $('<option value="' + value + '">' + text + '</option>');
    }
    
    function generateYears(select, from, to){       
        generateNumericSelect(select, from, to); 
    }
    
    function generateMonths(select){
        var json = [{key: 1, value: "January"},
                    {key: 2, value: "February"}];
                    
        generateSelectFromJSON(select, json);
    }
    
    function generateDays(select, year, month){
        var daysInMonth = new Date(year, month, 0).getDate();
        generateNumericSelect(select, 1, daysInMonth);        
    }
    
    function generateNumericSelect(select, from, to){
        $("option", select).remove();
        for(var i=from; i<=to; i++){
            select.append(getTagOption(i, i));
        }
    }
    
    function generateSelectFromJSON(select, json){        
        $("option", select).remove();
        $.each(json, function(i, item){
            select.append(getTagOption(item.key, item.value));
        });
    }

    function initDropDowns(){     
        var dateField =$("#date-001");   
        var year = $(".year", dateField);
        var month = $(".month", dateField);
        var day = $(".day", dateField);
        
        var yearStart = 2014;
        var yearStop = 2020;
        
        generateYears(year, yearStart, yearStop);
        generateMonths(month);
        generateDays(day, yearStart, 1);
        
        year.change(function(){
            generateDays(day, year.val(), 1);
            month.val("1");
            day.val("1");
        });
        
        month.change(function(){
            generateDays(day, year.val(), month.val());
            day.val("1");
        });
    }
  
    this.start = function()
    {
        initDropDowns();
        console.info("Ready");
    };
}

$(function() {
    window.app = new MyApp();
    window.app.start();
});
